	output d:\assemble\sources.v45\dots\dots.acx

OPT_GWVA_DEBUG_ERROR			; [option][root] generates an illegal when something goes wrong (for debugging purposes)
OPT_GWVA_DEBUG_PRINT_COMMENTS		; [option][root] print comments/warnings when assembling source

*OPT_GWVA_DEBUG_SEARCH_EXEC		; [option][root] is needed to do any log alert_box/logger
*OPT_GWVA_DEBUG_SEARCH_EXEC_IN_ALERT_BOX	; [option][root][LIB_HEXA][LIB_DECI][OPT_GWVA_DEBUG_SEARCH_EXEC] prints an alert box at each method distribution
*OPT_GWVA_DEBUG_SEARCH_EXEC_IN_LOGGER	; [option][root][LIB_HEXA][LIB_DECI][OPT_GWVA_DEBUG_SEARCH_EXEC] prints in log window each method distribution
*LIB_HEXA				; [none]
*LIB_DECI				; [none]

*GWVA_DEBUG_MSG_MAX_SIZE = 256		; [var] defines the debug message max length (generated by SEARCH_EXEC)
*GWVA_DEBUG_MAX_MSG_DEBUG_PENDING = 64	; [var] how many debug messages can be sent in a row

*PATCH_GWVA_ROOT_GEM_MESSAGE_PADDED16	; [option][MDL_GEM] aligns automatically the length of outgoing messages on multiple of 16 bytes

PATCH_GWVA_ROOT_GEM_EVNT_BTON_MB_0		; [option][MDL_GEM] patches the fact that a double event (message+bton) gives mouse_button=0

OPT_FULL_PATHNAMES
*OPT_DEBUG_IN_ACCESSORY_MODE
*OPT_DEBUG

	lea objet_application,a1

	include dots.def
	include visual45.s
	include dots.hs
	include dots.obj

	comment HEAD=7
	section TEXT

*---------------------------------------------------------------------------
my_inits_created:
	tst GWVA_ROOT_IS_ACC_PRG
	beq.s .acc

	bfset GWVA_WIND_OBJ_PROPERTIES(a0){GWVA_WIND_OLBIT_AMENU:1}	; menu principal
	bfset GWVA_WAPP_OBJ_PROPERTIES(a0){GWVA_WAPP_OLBIT_BACKGROUND:1}	; fond
.acc:
	clr.w ability	; DSP
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	;-------------------------------------------

acc_open:
menu_open:
	cmp.w #4,GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2
	beq.s .resolut_4bitpixel
	cmp.w #8,GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2
	bne.s .pas8bitpixel

.resolut_4bitpixel:
	move.l #'_SND',GWVA_ROOT_SEARCH_IN_OUT
	SUPEXEC GWVA_COOKIE_SEARCH_ONE_COOKIE
	tst.l GWVA_ROOT_SEARCH_IN_OUT
	beq.s .pas_56001
	move.l GWVA_ROOT_SEARCH_IN_OUT,a0
	move.l (a0),d0
	btst #4,d0
	beq.s .pas_56001

	lea objet_fenetre1,a0
	bsr GWVA_WIND_CREATE_OPEN_ONE_WIND
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.pas_56001:
	move #ALERT_NOT_56001,d0
	move #1,d1
	bsr GWVA_RSC_ALERT_BOX
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.pas8bitpixel:
	move #ALERT_NOT_4_8BIT,d0
	move #1,d1
	bsr GWVA_RSC_ALERT_BOX
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	;-------------------------------------------

menu_info:	lea objet_fenetre_info,a0
	bsr GWVA_WIND_CREATE_OPEN_ONE_WIND
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	;-------------------------------------------

acc_close:
menu_quit:
app_term:
	tst.w ability
	beq.s .pas_de_prg_dsp
	bsr FIN_DOTS
.pas_de_prg_dsp:

	; quoi qu'il arrive, il y a 1 delete all wind

	bsr GWVA_ROOT_KILL_APPLICATION

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

*---------------------------------------------------------------------

wind1_bton_ok_click:
	move.w struct_radio_bton+GWVA_FRADIO_OBJ_SELECTION,choix_objet_dots

	move.l a1,a0
	bsr GWVA_WIND_DELETE_ONE_WIND

	lea objet_fenetre2,a0

	bsr GWVA_ROOT_TEST_IF_OBJECT_CREATED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne .erreur_objet_pas_encore_cree

*	bsr GWVA_WIND_DELETE_ONE_WIND	; ceci ne marche pas car il est pip
	GWVA_CALL_METHOD_OTHER_OBJ	#GWVA_METHOD_DELETE
.erreur_objet_pas_encore_cree:


	lea objet_fenetre2,a0
	move.w GWVA_WBITM_OBJ_IMG_WIDTH(a0),d0
	mulu GWVA_WBITM_OBJ_IMG_HEIGHT(a0),d0
	clr.l d1
	move.w GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2,d1
	mulu.l d1,d0	; 4 ou 8 bits par pixels
	divu.l #8,d0	; taille du buffer en octet
	move.l d0,d1

	save.l d1/a0
	MXALLOC #MX_PREFTTRAM,d0
	load.l d1/a0
	tst.l d0
	beq.s .pas_de_memoire

	move.l d0,GWVA_WBITM_OBJ_DATA_PTR(a0)

	move.l d0,a1
.clear_buf:	clr.b (a1)+
	sub.l #1,d1
	bne.s .clear_buf

	move.l #colors_16,GWVA_WBITM_OBJ_PAL_PTR(a0)
	cmp.w #4,GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2
	beq.s .pixel_4bits
	move.l #colors_256,GWVA_WBITM_OBJ_PAL_PTR(a0)
.pixel_4bits:
	move.w GWVA_ROOT_VDI_WORKSTATION_EXTD+4*2,GWVA_WBITM_OBJ_NB_BITPLANES(a0)

	bsr GWVA_WIND_CREATE_OPEN_ONE_WIND

.pas_de_memoire:
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	;----------------------------------------------

wind1_bton_annule_click:
	move.l a1,a0
	bsr GWVA_WIND_DELETE_ONE_WIND
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

*---------------------------------------------------------------------
initialisation_fenetre:
	clr.l d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_UNREGISTER_TIMER

	save.l a0
	bsr INIT_DOTS
	load.l a0
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .erreur

	move.l #GWVA_METHOD_TIMER,d0
	move.l #16,d1		; 16 ms = 1/60 s
	move.w #GWVA_ROOT_MASK_TIMER_REARM,d2
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_REGISTER_TIMER

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
.erreur:
	bsr GWVA_WIND_DELETE_ONE_WIND
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts
	;----------------------------------------------

close_fenetre:
	bsr FIN_DOTS
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

	;----------------------------------------------

event_timer_dots:
	bsr GWVA_WIND_TEST_IF_WIND_OPENED
	cmp.w #GWVA_NO_ERROR_GENERIC,d7
	bne.s .pas_de_fenetre

	save.l a0
	bsr ROTATION_DOTS
	load.l a0

	GWVA_CALL_METHOD_OTHER_OBJ #GWVA_METHOD_WIND_REDRAW_ALL_CONTENTS
	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

.pas_de_fenetre:
	clr.l d0
	GWVA_CALL_METHOD_DIFF_METH_SAME_CLASS #GWVA_METHOD_UNREGISTER_TIMER

	moveq #GWVA_PRGRET_CONSUMED,d6
	rts

*---------------------------------------------------------------------

	include dotsme.s

*---------------------------------------------------------------------

	section DATA

colors_16:	dc.l $00000000
	dc.l $00FCFCFC
	dc.l $00DCDCDC,$00FCFCFC
	dc.l $00BCBCBC,$00FCFCFC,$007C7C7C,$00FCFCFC
	dc.l $009C9C9C,$00FCFCFC,$007C7C7C,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC

colors_256:	dc.l $00000000
	dc.l $00FCFCFC
	dc.l $00DCDCDC,$00FCFCFC
	dc.l $00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $007C7C7C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $005C5C5C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $007C7C7C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $003C3C3C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $007C7C7C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $005C5C5C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $007C7C7C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $001C1C1C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $007C7C7C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $005C5C5C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $007C7C7C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $003C3C3C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $007C7C7C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $005C5C5C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC
	dc.l $007C7C7C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC,$009C9C9C,$00FCFCFC,$00DCDCDC,$00FCFCFC,$00BCBCBC,$00FCFCFC,$00DCDCDC,$00FCFCFC

	section BSS

choix_objet_dots:	ds.w 1

 END
